<?xml version="1.0" encoding="UTF-8"?>
<!--
+========================================================================+
| IBM Confidential
| OCO Source Materials
| IBM Cognos Products: BUX
| (C) Copyright IBM Corp. 2009, 2011
|
| The source code for this program is not published or otherwise
| divested of its trade secrets, irrespective of what has been deposited
| with the U.S. Copyright Office.
+========================================================================+
-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:iw="http://www.ibm.com/xmlns/prod/iWidget" exclude-result-prefixes="iw">
	<xsl:output method="html" encoding="UTF-8" indent="no" standalone="yes" doctype-public="-//W3C//DTD HTML 4.01 Transitional//EN" doctype-system="http://www.w3.org/TR/html4/loose.dtd" omit-xml-declaration="yes"/>
	<xsl:param name="basepath" select="'../com.ibm.cognos.ui.webcontent/data'"/>
	<xsl:variable name="tabs" select="'&#9;&#9;&#9;&#9;&#9;&#9;&#9;&#9;&#9;&#9;'"/>
	<xsl:variable name="instances" select="//iw:widgetInstance"/>
	<xsl:variable name="instances_path">
		<xsl:for-each select="$instances">
			<path src="{ $basepath }{ @src }"/>
		</xsl:for-each>
	</xsl:variable>
	<xsl:variable name="iwidgets" select="document($instances_path/path/@src)"/>
	<xsl:template match="*">
		<xsl:copy>
			<xsl:apply-templates select="*|@*|text()|comment()"/>
		</xsl:copy>
	</xsl:template>
	<xsl:template match="@*">
		<xsl:copy-of select="."/>
	</xsl:template>
	<xsl:template match="text()">
		<xsl:value-of select="."/>
	</xsl:template>
	<xsl:template match="comment()">
		<xsl:comment>
			<xsl:value-of select="."/>
		</xsl:comment>
	</xsl:template>
	<xsl:template match="html">
		<xsl:text>&#10;</xsl:text>
		<xsl:copy>
			<xsl:apply-templates select="*|@*|text()|comment()"/>
		</xsl:copy>
	</xsl:template>
	<xsl:template match="iw:widgetInstance">
		<xsl:variable name="me" select="$iwidgets/iw:iwidget[@id = current()/@ref]"/>
		<xsl:variable name="others" select="$iwidgets/iw:iwidget[@id != current()/@ref]"/>
		<xsl:variable name="ident" select="count(ancestor::*)"/>
		<xsl:if test="count($me) != 1">
			<xsl:message terminate="yes">FATAL ERROR: unable to load iwidget's xml definition for <xsl:value-of select="current()/@ref"/>.</xsl:message>
		</xsl:if>
		<div>
			<xsl:copy-of select="@*[name()!='ref' and name()!='src' and name()!='out']"/>
			<xsl:attribute name="class">mm_iWidget</xsl:attribute>
			<xsl:if test="@out">
				<xsl:text>&#10;</xsl:text>
				<xsl:value-of select="substring($tabs, 1, $ident + 1)"/>
				<xsl:comment> ===== DELAYED WIDGET (<xsl:value-of select="@out"/>) ===== CUT START ===== </xsl:comment>
			</xsl:if>
			<xsl:text>&#10;</xsl:text>
			<xsl:value-of select="substring($tabs, 1, $ident + 1)"/>
			<a class="mm_Definition" href="$mainFolder{ @src }" tabIndex="-1"/>
			<xsl:text>&#10;</xsl:text>
			<xsl:apply-templates select="iw:*"/>
			<xsl:for-each select="$me/iw:event[@handled='true']">
				<xsl:variable name="event_id" select="@id"/>
				<xsl:for-each select="$others/iw:event[@published='true' and @id = $event_id]">
					<xsl:variable name="source_id" select="../@id"/>
					<xsl:value-of select="substring($tabs, 1, $ident + 1)"/>
					<span class="mm_ReceivedEvent">
						<xsl:text>&#10;</xsl:text>
						<xsl:value-of select="substring($tabs, 1, $ident + 2)"/>
						<a class="mm_SourceEvent" href="#{ $instances[@ref = $source_id]/@id }" style="visibility:hidden">
							<xsl:value-of select="$event_id"/>
						</a>
						<xsl:text>&#10;</xsl:text>
						<xsl:value-of select="substring($tabs, 1, $ident + 2)"/>
						<span class="mm_TargetEvent" style="visibility:hidden">
							<xsl:value-of select="$event_id"/>
						</span>
						<xsl:text>&#10;</xsl:text>
						<xsl:value-of select="substring($tabs, 1, $ident + 1)"/>
					</span>
					<xsl:text>&#10;</xsl:text>
				</xsl:for-each>
			</xsl:for-each>
			<xsl:if test="@out">
				<xsl:value-of select="substring($tabs, 1, $ident + 1)"/>
				<xsl:comment> ===== DELAYED WIDGET (<xsl:value-of select="@out"/>) ===== CUT END ===== </xsl:comment>
				<xsl:text>&#10;</xsl:text>
			</xsl:if>
			<xsl:value-of select="substring($tabs, 1, $ident)"/>
		</div>
	</xsl:template>
	<xsl:template match="iw:itemSet">
		<xsl:variable name="ident" select="count(ancestor::*)"/>
		<xsl:value-of select="substring($tabs, 1, $ident)"/>
		<span class="mm_ItemSet" title="{@id}">
			<xsl:apply-templates/>
		</span>
		<xsl:text>&#10;</xsl:text>
	</xsl:template>
	<xsl:template match="iw:item">
		<a class="mm_Item" href="#{ @id }" style="visibility:hidden">
			<xsl:value-of select="@value"/>
		</a>
	</xsl:template>
</xsl:stylesheet>
